﻿namespace GravityGun
{
    using System;
    using System.Windows.Forms;
    using GTA;
    using GTA.Native;

    public class Main : Script
    {
        const float BLAST_POWER = 50f;

        float distance;
        float Distance
        {
            set { distance = MouseWheel.Distance = value; }
        }
        Vector3 gravityPoint;

        public Main()
        {
            Tick += Main_Tick;
            BindKey(Keys.Delete, ToggleMode);
            BindKey(Keys.Delete, true, false, false, ToggleSingleItem);
            BindKey(Keys.Space, BlastObjects);
        }

        void BlastObjects()
        {
            if (mode == 0) return;
            if (getDistance) return;

            if (mode == 1)
            {
                if (singleItem)
                {
                    if (Game.Exists(singlePed)) { singlePed.ApplyForce(Game.CurrentCamera.Direction * BLAST_POWER); singlePed = null; }
                }
                else
                {
                    foreach (Ped ped in World.GetPeds(gravityPoint, 3.5f))
                    {
                        if (!Game.Exists(ped)) continue;
                        if (ped == Game.LocalPlayer.Character) continue;

                        ped.ApplyForce(Game.CurrentCamera.Direction * BLAST_POWER);
                    }
                }
            }
            else if (mode == 2)
            {
                if (singleItem)
                {
                    if (Game.Exists(singleVehicle)) { singleVehicle.ApplyForce(Game.CurrentCamera.Direction * BLAST_POWER); singleVehicle = null; }
                }
                else
                {
                    foreach (Vehicle veh in World.GetVehicles(gravityPoint, 6f))
                    {
                        if (!Game.Exists(veh)) continue;

                        veh.ApplyForce(Game.CurrentCamera.Direction * BLAST_POWER);
                    }
                }
            }
            else
            {
                if (singleItem)
                {
                    if (Game.Exists(singleObject)) { singleObject.ApplyForce(Game.CurrentCamera.Direction * BLAST_POWER); singleObject = null; }
                }
                else
                {
                    foreach (GTA.Object obj in World.GetAllObjects())
                    {
                        if (!Game.Exists(obj)) continue;
                        if (obj.Position.DistanceTo(gravityPoint) > 6f) continue;

                        obj.ApplyForce(Game.CurrentCamera.Direction * BLAST_POWER);
                    }
                }
            }
        }

        bool singleItem; Ped singlePed; Vehicle singleVehicle; GTA.Object singleObject;
        void ToggleSingleItem()
        {
            singleItem = !singleItem;
            Game.DisplayText("Pick Up Mode: " + (singleItem ? "Single" : "Multi"));
        }
        void NullSingleItems()
        {
            singlePed = null;
            singleVehicle = null;
            singleObject = null;
        }

        bool getDistance;
        int mode;

        void ToggleMode()
        {
            mode++;
            mode = mode > 3 ? 0 : mode;
            Game.DisplayText("Gravity Gun Mode: " + (mode == 0 ? "Off" : mode == 1 ? "Ped" : mode == 2 ? "Vehicle" : "Object"));
        }
        void DebugText()
        {
            Game.DisplayText("Finding Ped: " + getDistance.ToString() + Environment.NewLine +
                             "Distance: " + distance.ToString());
        }
        void Main_Tick(object sender, EventArgs e)
        {
            //DebugText();
            if (mode == 0) return;
            if (Game.LocalPlayer.Character.Weapons.CurrentType != Weapon.Handgun_DesertEagle &&
                Game.LocalPlayer.Character.Weapons.CurrentType != Weapon.Handgun_Glock) { getDistance = true; NullSingleItems(); return; }
            if (!Game.isGameKeyPressed(GameKey.Aim)) { getDistance = true; NullSingleItems(); return; }
            if (!Game.isGameKeyPressed(GameKey.Action)) { getDistance = true; NullSingleItems(); return; }

            distance = MouseWheel.Distance;

            if (mode == 1)
            {
                if (getDistance)
                {
                    Ped targeted = Game.LocalPlayer.GetTargetedPed();

                    if (!Game.Exists(targeted)) return;

                    Distance = targeted.Position.DistanceTo(Game.CurrentCamera.Position);
                    if (singleItem) singlePed = targeted;
                    getDistance = false;
                    return;
                }

                gravityPoint = Game.CurrentCamera.Position + Game.CurrentCamera.Direction * distance;

                if (singleItem)
                {
                    if (Game.Exists(singlePed))
                    {
                        singlePed.isRagdoll = true;
                        singlePed.ApplyForce(Vector3.Normalize(gravityPoint - singlePed.Position) * 0.75f);
                    }
                }
                else
                {

                    Ped[] pedArray = World.GetPeds(gravityPoint, 3f);

                    foreach (Ped ped in pedArray)
                    {
                        if (!Game.Exists(ped) || ped == Game.LocalPlayer.Character) continue;

                        ped.isRagdoll = true;
                        ped.ApplyForce(Vector3.Normalize(gravityPoint - ped.Position) * 0.75f);
                    }
                }
            }
            else if (mode == 2)
            {
                if (getDistance)
                {
                    for (int i = 1; i < 75; i++)
                    {
                        foreach (Vehicle v in World.GetVehicles(Game.CurrentCamera.Position + Game.CurrentCamera.Direction * i, 1f))
                        {
                            if (!Game.Exists(v)) continue;
                            if (!v.isOnScreen) continue;

                            Distance = v.Position.DistanceTo(Game.CurrentCamera.Position);
                            if (singleItem) singleVehicle = v;
                            getDistance = false;
                            return;
                        }
                    }
                    return;
                }

                gravityPoint = Game.CurrentCamera.Position + Game.CurrentCamera.Direction * distance;

                if (singleItem)
                {
                    if (Game.Exists(singleVehicle))
                    {
                        singleVehicle.ApplyForce(Vector3.Normalize(gravityPoint - singleVehicle.Position) * 0.5f);
                    }
                }
                else
                {
                    Vehicle[] vehArray = World.GetVehicles(gravityPoint, 5f);

                    foreach (Vehicle veh in vehArray)
                    {
                        if (!Game.Exists(veh)) continue;
                        if (!veh.isOnScreen) continue;

                        veh.ApplyForce(Vector3.Normalize(gravityPoint - veh.Position) * 0.5f);
                    }
                }
            }
            else
            {
                if (getDistance)
                {
                    GTA.Object[] oArray = World.GetAllObjects();

                    for (int i = 5; i < 75; i++)
                    {
                        Vector3 pos = Game.CurrentCamera.Position + Game.CurrentCamera.Direction * i;
                        foreach (GTA.Object o in oArray)
                        {
                            if (!Game.Exists(o)) continue;

                            if (o.Position.DistanceTo(pos) < 1f)
                            {
                                Distance = o.Position.DistanceTo(Game.CurrentCamera.Position);
                                if (singleItem) singleObject = o;
                                getDistance = false;
                                return;
                            }
                        }
                    }
                    return;
                }

                gravityPoint = Game.CurrentCamera.Position + Game.CurrentCamera.Direction * distance;

                if (singleItem)
                {
                    if (Game.Exists(singleObject))
                    {
                        singleObject.ApplyForce(Vector3.Normalize(gravityPoint - singleObject.Position) * 0.65f);
                    }
                }
                else
                {
                    GTA.Object[] objArray = World.GetAllObjects();

                    foreach (GTA.Object obj in objArray)
                    {
                        if (!Game.Exists(obj)) continue;
                        if (obj.Position.DistanceTo(gravityPoint) > 5f) continue;

                        obj.ApplyForce(Vector3.Normalize(gravityPoint - obj.Position) * 0.65f);
                    }
                }
            }
        }
    }
    public class MouseWheel : Script
    {
        private static float _distance;
        internal static float Distance
        {
            get { return _distance; }
            set { _distance = value; }
        }

        public MouseWheel()
        {
            Tick += Wheel_Tick;
        }

        void Wheel_Tick(object sender, EventArgs e)
        {
            if (Game.isGameKeyPressed(GameKey.NextWeapon))
            {
                _distance++;
                Game.DisplayText("Object Distance: " + (_distance - 2).ToString("n0"));
                return;
            }
            if (Game.isGameKeyPressed(GameKey.LastWeapon))
            {
                _distance--; _distance = _distance < 0 ? 0 : _distance;
                Game.DisplayText("Object Distance: " + (_distance - 2).ToString("n0"));
            }
        }
    }
}